//
// gritdlg.cpp
//   gritdlg implementation file
// (20050908 - 20070402, cearn)
//
// === NOTES === 
// * Minor changes for libgrit 0.7


#include "stdafx.h"
#include "wingrit.h"
#include "resource.h"
#include "gritdlg.h"
#include "FileFilter.h"
#include "LogDlg.h"

#include <cldib.h>
#include <grit.h>

#include "fi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// === CONSTANTS ======================================================

extern const int cObjSizes[12][2];

const int cObjSizes[12][2]= 
{
	{1,1}, {2,2}, {4,4}, {8,8}, 
	{2,1}, {4,1}, {4,2}, {8,4}, 
	{1,2}, {1,4}, {2,4}, {4,8}
};


// to avoid msg-box on empty field
static void AFXAPI DDX_IntHack(CDataExchange* pDX, int nIDC, int& value)
{
	if(pDX->m_bSaveAndValidate)
	{
		char str[32];
		if(::GetWindowText(pDX->PrepareEditCtrl(nIDC), str, 32) != 0)
			DDX_Text(pDX, nIDC, value);
		else 
			value= 0;
	}
	else
		DDX_Text(pDX, nIDC, value);
}

/////////////////////////////////////////////////////////////////////////////
// CxpGbaDlg dialog

CxpGbaDlg::CxpGbaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CxpGbaDlg::IDD, pParent)
{
	mDstDir= "";
	mDstTitle= "";
	mgr= grit_alloc();
	//- mgr= xgi_create();
	//{{AFX_DATA_INIT(CxpGbaDlg)
	mbPal = TRUE;
	mPalStart = 0;
	mPalCount = 256;
	mPalTrans = 0;
	mbImg = TRUE;
	mImgMode = 0;
	mImgBpp = 3;
	mImgCprs = 0;
	mImgTransStr = _T("FF00FF");
	mbMap = FALSE;
	moMapFormat = 0;
	mbMapRdx = TRUE;
	mbMapRdxFlip = TRUE;
	mbMapRdxPal = TRUE;
	mbMetaPal = FALSE;
	mMapCprs = 0;
	mMapOffset = 0;
	mbObjCustom = FALSE;
	moObjShape = 0;
	moObjSize = 0;
	mObjHorz = 1;
	mObjVert = 1;
	moAreaSize = 1;
	mAreaLeft = 0;
	mAreaTop = 0;
	mAreaWidth = 8;
	mAreaHeight = 8;
	mDstPath = _T("");
	mFileType = 0;
	moVarChunk = 1;
	mbHeader = TRUE;
	mbAppend = FALSE;
	mbSymChk = FALSE;
	mSymName = _T("bar");
	mbTileset = FALSE;
	mTilesetPath = _T("");
	//}}AFX_DATA_INIT
	mSummary = "";
	mbBusy= FALSE;
}

CxpGbaDlg::~CxpGbaDlg()
{
	grit_free(mgr);
}

void CxpGbaDlg::DoDataExchange(CDataExchange* pDX)
{
	mbBusy=TRUE;
	CDialog::DoDataExchange(pDX);
	DDX_IntHack(pDX, IDC_START, mPalStart);
	DDV_MinMaxInt(pDX, mPalStart, 0, 255);
	DDX_IntHack(pDX, IDC_COUNT, mPalCount);
	DDV_MinMaxInt(pDX, mPalCount, 0, 256);
	DDX_IntHack(pDX, IDC_OBJ_HORZ, mObjHorz);
	DDV_MinMaxInt(pDX, mObjHorz, 0, 256);
	DDX_IntHack(pDX, IDC_OBJ_VERT, mObjVert);
	DDV_MinMaxInt(pDX, mObjVert, 0, 256);
	DDX_IntHack(pDX, IDC_LEFT, mAreaLeft);
	DDX_IntHack(pDX, IDC_TOP, mAreaTop);
	DDX_IntHack(pDX, IDC_WIDTH, mAreaWidth);
	DDX_IntHack(pDX, IDC_HEIGHT, mAreaHeight);
	//{{AFX_DATA_MAP(CxpGbaDlg)
	DDX_Check(pDX, IDC_PAL_CHK, mbPal);
	DDX_Text(pDX, IDC_PAL_TRANS, mPalTrans);
	DDV_MinMaxByte(pDX, mPalTrans, 0, 255);

	DDX_Check(pDX, IDC_IMG_CHK, mbImg);
	DDX_CBIndex(pDX, IDC_IMG_MODE, mImgMode);
	DDX_CBIndex(pDX, IDC_IMG_BPP, mImgBpp);
	DDX_CBIndex(pDX, IDC_IMG_CPRS, mImgCprs);
	DDX_Text(pDX, IDC_IMG_TRANS, mImgTransStr);
	DDV_MaxChars(pDX, mImgTransStr, 8);

	DDX_Check(pDX, IDC_OBJ_CUSTOM, mbObjCustom);
	DDX_Radio(pDX, IDC_OBJ_SQR, moObjShape);
	DDX_Radio(pDX, IDC_OBJ_8, moObjSize);

	DDX_Check(pDX, IDC_MAP_CHK, mbMap);
	DDX_Check(pDX, IDC_MAP_RDX, mbMapRdx);
	DDX_Check(pDX, IDC_MAP_RDX_FLIP, mbMapRdxFlip);
	DDX_Check(pDX, IDC_MAP_RDX_PAL, mbMapRdxPal);
	DDX_Check(pDX, IDC_META_PAL, mbMetaPal);
	DDX_CBIndex(pDX, IDC_MAP_CPRS, mMapCprs);
	DDX_Text(pDX, IDC_MAP_OFS, mMapOffset);

	DDX_Radio(pDX, IDC_AREA_CSM, moAreaSize);

	DDX_Text(pDX, IDC_FILE_PATH, mDstPath);
	DDX_CBIndex(pDX, IDC_FILE_TYPE, mFileType);
	DDX_Radio(pDX, IDC_VAR_8, moVarChunk);
	DDX_Check(pDX, IDC_FILE_HDR, mbHeader);
	DDX_Check(pDX, IDC_FILE_CAT, mbAppend);
	DDX_Check(pDX, IDC_VAR_CHK, mbSymChk);
	DDX_Text(pDX, IDC_VAR_NAME, mSymName);
	DDV_MaxChars(pDX, mSymName, 256);
	DDX_Check(pDX, IDC_TILESET_CHK, mbTileset);
	DDX_Text(pDX, IDC_TILESET_PATH, mTilesetPath);
	//}}AFX_DATA_MAP
	mbBusy= FALSE;
}


BEGIN_MESSAGE_MAP(CxpGbaDlg, CDialog)
	//{{AFX_MSG_MAP(CxpGbaDlg)
	ON_BN_CLICKED(IDC_PAL_CHK, OnPalChk)
	ON_BN_CLICKED(IDC_IMG_CHK, OnImgChk)
	ON_CBN_SELENDOK(IDC_IMG_MODE, OnSelendokImgMode)
	ON_BN_CLICKED(IDC_MAP_CHK, OnMapChk)
	ON_BN_CLICKED(IDC_OBJ_CUSTOM, OnObjCustom)
	ON_CBN_SELENDOK(IDC_FILE_TYPE, OnSelendokFileType)
	ON_BN_CLICKED(IDC_VAR_CHK, OnVarChk)
	ON_BN_CLICKED(IDC_FILE_BROWSE, OnFileBrowse)
	ON_BN_CLICKED(ID_APPLY_NOW, OnValidate)
	ON_BN_CLICKED(IDC_MAP_RDX, OnMapRdx)
	ON_BN_CLICKED(IDC_TILESET_CHK, OnTilesetChk)
	ON_BN_CLICKED(IDC_TILESET_BROWSE, OnTilesetBrowse)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_AREA_CSM, IDC_AREA_SEL, OnAreaFormat)
END_MESSAGE_MAP()


// === Implementation =================================================


//! Update palette controls for changes made elsewhere
void CxpGbaDlg::UpdatePal()
{
	GetDlgItem(IDC_START)->EnableWindow(mbPal);
	GetDlgItem(IDC_COUNT)->EnableWindow(mbPal);
	GetDlgItem(IDC_PAL_TRANS)->EnableWindow(mbPal);
}


//! Update image controls for changes made elsewhere
void CxpGbaDlg::UpdateImg()
{
	GetDlgItem(IDC_IMG_MODE)->EnableWindow(mbImg);
	GetDlgItem(IDC_IMG_BPP)->EnableWindow(mbImg);
	GetDlgItem(IDC_IMG_CPRS)->EnableWindow(mbImg);

	GetDlgItem(IDC_IMG_TRANS)->EnableWindow(mbImg && mImgMode==IMG_MODE_BMP_T);
}

//! Update map controls for changes made elsewhere
void CxpGbaDlg::UpdateMap()
{
	BOOL bMap= IsMap();

	GetDlgItem(IDC_MAP_CHK)->EnableWindow(IsTiles());

	GetDlgItem(IDC_MAP_FLAT)->EnableWindow(bMap);
	GetDlgItem(IDC_MAP_SBB)->EnableWindow(bMap);
	GetDlgItem(IDC_MAP_AFF)->EnableWindow(bMap);
	GetDlgItem(IDC_MAP_RDX)->EnableWindow(bMap);
	UpdateRdx();
	GetDlgItem(IDC_META_PAL)->EnableWindow(bMap);
	GetDlgItem(IDC_MAP_CPRS)->EnableWindow(bMap);
	GetDlgItem(IDC_MAP_OFS)->EnableWindow(bMap);

	GetDlgItem(IDC_TILESET_CHK)->EnableWindow(bMap);

	BOOL bTileset= bMap && mbTileset;
	GetDlgItem(IDC_TILESET_PATH)->EnableWindow(bTileset);
	GetDlgItem(IDC_TILESET_BROWSE)->EnableWindow(bTileset);
}


//! Update tile reduction controls for changes made elsewhere
void CxpGbaDlg::UpdateRdx()
{
	BOOL bRdx= IsRdx();
	GetDlgItem(IDC_MAP_RDX_PAL)->EnableWindow(bRdx);
	GetDlgItem(IDC_MAP_RDX_FLIP)->EnableWindow(bRdx);
}

//! Update meta-tiling controls for changes made elsewhere
void CxpGbaDlg::UpdateObj()
{
	int ii;

	BOOL bFixed=FALSE, bCustom=FALSE;
	if(IsTiles())	// if tiles on 
		mbObjCustom==TRUE ? bCustom=TRUE : bFixed=TRUE;
	
	// custom checkbox
	GetDlgItem(IDC_OBJ_CUSTOM)->EnableWindow(IsTiles());
	// fixed sizes
	for(ii=IDC_OBJ_SQR; ii<=IDC_OBJ_TALL; ii++)
		GetDlgItem(ii)->EnableWindow(bFixed);
	for(ii=IDC_OBJ_8; ii<=IDC_OBJ_64; ii++)
		GetDlgItem(ii)->EnableWindow(bFixed);
	// var sizes
	GetDlgItem(IDC_OBJ_HORZ)->EnableWindow(bCustom);
	GetDlgItem(IDC_OBJ_VERT)->EnableWindow(bCustom);
}

//! Update area controls for changes made elsewhere
void CxpGbaDlg::UpdateArea()
{
	BOOL bCustom= IsAreaCstm();

	GetDlgItem(IDC_LEFT)->EnableWindow(bCustom);
	GetDlgItem(IDC_TOP)->EnableWindow(bCustom);
	GetDlgItem(IDC_WIDTH)->EnableWindow(bCustom);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(bCustom);
}

// TODO: reformat for new options
void CxpGbaDlg::UpdateSummary()
{
	// anti-bounce code (trust me, you need this)
	if(!mbBusy)
		UpdateData(TRUE);
	DWORD dw;
	CString sPal, sImg, sArea, sMeta, sMap, sFiles;
	CString str;
	BOOL bPal, bImg, bMeta, bMap, bArea;

	ASSERT(moMapFormat<3);

	bPal= mbPal;
	bImg= mbImg;
	bArea= mbImg || mbMap;
	bMeta= GetDlgItem(IDC_OBJ_CUSTOM)->IsWindowEnabled();
	bMap= mbMap && IsTiles();

	// TODO: Validation!!!

	// --- image ---
	if(bImg)
	{
		// TODO: transparent color
		GetDlgItem(IDC_IMG_MODE)->GetWindowText(str);
		sImg= "img: " + str;
		if(mImgMode == IMG_MODE_BMP_T)
		{
			RGBQUAD rgb= str2rgb(mImgTransStr);
			str.Format(" (%d, %d, %d)", rgb.rgbRed, rgb.rgbGreen, rgb.rgbBlue);
			sImg += str;
		}
		str.Format(", %dbpp, cprs: ", (1<<mImgBpp));
		sImg += str;
		GetDlgItem(IDC_IMG_CPRS)->GetWindowText(str);
		sImg += str;
	}
	else
		sImg= "img: -";
	
	// --- area ---
	if(bArea)
	{
		dw= moAreaSize+IDC_AREA_CSM;
		if(dw == IDC_AREA_CSM)
		{
			sArea.Format("area: (%d,%d)-(%d,%d)   [%d, %d]", 
				mAreaLeft, mAreaTop, mAreaLeft+mAreaWidth, mAreaTop+mAreaHeight, 
				mAreaWidth, mAreaHeight);
		}
		else if(dw == IDC_AREA_IMG)
		{
			sArea.Format("area: (%d,%d)-(%d,%d)   [%d, %d]", 
				0, 0, dib_get_width(mpDib), dib_get_height(mpDib), 
				dib_get_width(mpDib), dib_get_height(mpDib));
		}
	}
	else
		sArea="area: -";

	// --- object ---
	if(bMeta)
	{
		SIZE sz;
		if(mbObjCustom)
		{	sz.cx= mObjHorz; sz.cy= mObjVert;	}
		else
		{
			sz.cx= cObjSizes[moObjShape*4 + moObjSize][0];
			sz.cy= cObjSizes[moObjShape*4 + moObjSize][1];
		}

		sMeta.Format("meta: %dx%d tiles (%dx%d px)", 
			sz.cx, sz.cy, sz.cx<<3, sz.cy<<3);
	}
	else
		sMeta= "obj: -";

	// --- map ---
	if(bMap)
	{
		dw= moMapFormat+IDC_MAP_FLAT;
		switch(dw)
		{
		case IDC_MAP_FLAT:
			str= "flat";	break;
		case IDC_MAP_SBB:
			str= "in SBBs";	break;
		case IDC_MAP_AFF:
			str= "affine";	break;
		}
		sMap.Format("map: %s, +%d ", str, mMapOffset);
		if(IsRdx())
		{
			sMap += "reduced [t";
			if(mbMapRdxFlip)
				sMap += "f";
			if(mbMapRdxPal)
				sMap += "p";
			sMap += "]";
		}
	}
	else
		sMap= "map: -";
	
	// --- palette ---
	if(bPal)
	{
		if(mPalStart+mPalCount>256)
			mPalCount= 256-mPalStart;
		//GetDlgItem(IDC_START)->GetWindowText(str);
		sPal.Format("pal: %d-%d [%d]", mPalStart, mPalStart+mPalCount, mPalCount);

		// TODO: palette transparency index
	}
	else
		sPal= "pal: -";

	// --- files ---
	// TODO: add tileset file

	switch(mFileType)
	{
	case FMT_C:		// C (+h)
		str= mDstTitle + ".c   ";
		break;
	case FMT_GAS:		// assembly (+h)
		str= mDstTitle + ".s   ";
		break;
	case -1:		// COFF (+h)
		str= mDstTitle + ".o   ";
		break;
	case FMT_BIN:
		str.Empty();
		if(bPal)
			str += mDstTitle + ".pal.bin   ";
		if(bImg)
			str += mDstTitle + ".img.bin   ";
		if(bMap)
			str += mDstTitle + ".map.bin   ";
	case FMT_GBFS:
		str= mDstTitle + ".gbfs   ";
	}

	sFiles= "files:  ";

	if(mbHeader)
		sFiles += mDstTitle + ".h   ";
	sFiles += str;

	mSummary.Format("%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s", sImg, sArea, 
		sMeta, sMap, sPal, sFiles);
	GetDlgItem(IDC_SUMMARY)->SetWindowText(mSummary);
}


void CxpGbaDlg::UpdateOptString()
{
	// anti-bounce code (trust me, you need this)
	if(!mbBusy)
		UpdateData(TRUE);

	//DWORD dw;
	CString sPal, sImg, sArea, sMeta, sMap, sFile;
	CString str;
	BOOL bPal, bImg, bMeta, bMap, bArea;

	ASSERT(moMapFormat<3);

	bPal= mbPal;
	bImg= mbImg;
	bArea= mbImg || mbMap;
	bMeta= GetDlgItem(IDC_OBJ_CUSTOM)->IsWindowEnabled();
	bMap= mbMap && IsTiles();


	// --- Output options ---
	sFile.Format(" -o [dir]/%s.%s", mDstTitle, cFileTypes[mFileType]);
	if(mbSymChk)
		sFile += " -s " + mSymName;
	if(!mbHeader)
		sFile += " -fh!";
	if(mbAppend)
		sFile += " -fa";
	if(mbMap && mbTileset)
	{
		CFileFilter::GetFileName(mTilesetPath, str);
		sFile += " -fx [dir]/" + str;
	}

	// TODO: add rest of options


	// --- Image ---

	// --- Area ---

	// --- Mapping ---

	// --- Meta ---

	// --- Palette ---

	// --- Rest ---

}


BOOL CxpGbaDlg::UpdateGitRec(BOOL b2gr)
{
	DWORD dw;
	char str[MAXPATHLEN];

	// TODO: al/img trans ; img modes ; tileset

	if(b2gr)	// data -> gr
	{
		UpdateData(TRUE);

		SetDstPath(mDstPath);

		// clear previous gr data
		grit_clear(mgr);
		grs_clear(mgr->shared);

		// Yes, yes, very wasteful
		mgr->src_dib= dib_clone(mpDib);

		if(mbHeader)
			mgr->file_flags |= GRIT_FILE_H;
		if(mbAppend)
			mgr->file_flags |= GRIT_FILE_CAT;
		mgr->file_flags |= BF_PREP(mFileType, GRIT_FTYPE);

		// TODO check whether this is all OK!!
		if(mbSymChk)
			mgr->sym_name= strdup(mSymName);
		else
			mgr->sym_name= strdup(mDstTitle);
		// make sure it's a valid C varname
		str_fix_ident(mgr->sym_name, mgr->sym_name, 
			strlen(mgr->sym_name));

		sprintf(str, "%s/%s.%s", mDstDir, mDstTitle, cFileTypes[mFileType]);
		mgr->dst_path= strdup(str);

		// --- palette ---
		if(mbPal)
		{
			mgr->pal_flags |= GRIT_INCL;

			mgr->pal_start= mPalStart;
			mgr->pal_end= mPalStart+mPalCount;
			if(mgr->pal_end > 256)
				mgr->pal_end= 256;

			if(mPalTrans != 0)
			{
				mgr->pal_flags |= GRIT_PAL_TRANS;
				mgr->pal_trans= mPalTrans;
			}
		}

		// --- image ---
		// NOTE: we should probably always process the image, 
		//   just not necessarily export
		if(1)
		{
			if(mbImg)
				mgr->img_flags |= GRIT_INCL;

			switch(mImgMode)
			{
			case IMG_MODE_TILE:
				mgr->img_flags |= GRIT_IMG_TILE;
				break;
			case IMG_MODE_BMP:
				mgr->img_flags |= GRIT_IMG_BMP;
				break;
			case IMG_MODE_BMP_A:
				mgr->img_flags |= GRIT_IMG_BMP | GRIT_IMG_BMP_A;
				break;
			case IMG_MODE_BMP_T:
				mgr->img_flags |= GRIT_IMG_BMP;

				// Empty color && non-zero pal-trans -> use pal-trans
				// Empty color otherwise: use FF00FF
				// non-empty: use non-empty
				dw= strlen(mImgTransStr);

				if( dw != 0 || !(mgr->pal_flags & GRIT_PAL_TRANS) )
				{
					if(dw==0)
						mImgTransStr= "FF00FF";
					mgr->img_trans= str2rgb(mImgTransStr);

					mgr->img_flags |= GRIT_IMG_TRANS;
				}
				break;				
			}

			mgr->img_ofs= 0;
			mgr->img_bpp= 1<<mImgBpp;

			switch(mImgCprs)
			{
			case CPRS_LZ:
				mgr->img_flags |= GRIT_CPRS_LZ77;
				break;
			case CPRS_HUFF:
				mgr->img_flags |= GRIT_CPRS_HUFF;
				break;
			case CPRS_RLE:
				mgr->img_flags |= GRIT_CPRS_RLE;
				break;
			}
		}
		// --- map ---
		if(mbMap)
		{
			mgr->map_flags |= GRIT_INCL;
			switch(moMapFormat+IDC_MAP_FLAT)
			{
			case IDC_MAP_SBB:
				mgr->map_flags |= GRIT_MAP_REG;	break;
			case IDC_MAP_AFF:
				mgr->map_flags |= GRIT_MAP_AFF;	break;
			}

			if(mbMapRdx)
			{
				mgr->map_flags |= GRIT_RDX_ON;
				if(mbMapRdxFlip)
					mgr->map_flags |= GRIT_RDX_FLIP;
				if(mbMapRdxPal)
					mgr->map_flags |= GRIT_RDX_PAL;
			}

			if(mbMetaPal)
				mgr->map_flags |= GRIT_META_PAL;


			switch(mMapCprs)
			{
			case CPRS_LZ:
				mgr->map_flags |= GRIT_CPRS_LZ77;
				break;
			case CPRS_HUFF:
				mgr->map_flags |= GRIT_CPRS_HUFF;
				break;
			case CPRS_RLE:
				mgr->map_flags |= GRIT_CPRS_RLE;
				break;
			}
			mgr->map_ofs= mMapOffset;

			// Add external tileset stuff
			if(mbTileset)
			{
				if(mTilesetPath.IsEmpty())
					mTilesetPath= mDstDir + mDstTitle + "tiles.bmp";
				mgr->shared->path= strdup(mTilesetPath);
				mgr->img_flags |= GRIT_IMG_SHARED;
			}
		}

		if(mbObjCustom)
		{
			mgr->meta_width= mObjHorz;
			mgr->meta_height= mObjVert;
		}
		else
		{
			dw= moObjShape*4 + moObjSize;
			mgr->meta_width= cObjSizes[dw][0];
			mgr->meta_height= cObjSizes[dw][1];
		}
		// area
		dw= moAreaSize+IDC_AREA_CSM;
		if(dw == IDC_AREA_CSM)
		{
			mgr->area_left= mAreaLeft;
			mgr->area_top= mAreaTop;
			mgr->area_right= mAreaLeft+mAreaWidth;
			mgr->area_bottom= mAreaTop+mAreaHeight;
		}
		else
		{
			mgr->area_left= 0;
			mgr->area_top= 0;
			mgr->area_right= dib_get_width(mpDib);
			mgr->area_bottom= dib_get_height(mpDib);
		}
		switch(moVarChunk+IDC_VAR_8)
		{
		case IDC_VAR_8:		dw=GRIT_U8;  break;
		case IDC_VAR_16:	dw= GRIT_U16; break;
		case IDC_VAR_32:	dw= GRIT_U32; break;
		}

		mgr->pal_flags |= dw;
		mgr->img_flags |= dw;
		mgr->map_flags |= dw;
	}
	else		// gr -> data
	{
		// --- file ---
		mbHeader = (mgr->file_flags & GRIT_FILE_H) != 0;
		mbAppend = (mgr->file_flags & GRIT_FILE_CAT) != 0;
		
		// --- palette ---
		mPalStart= mgr->pal_start;
		mPalCount= mgr->pal_end-mgr->pal_start;
		mPalTrans= mgr->pal_trans;

		// --- image ---
		if(mgr->img_flags & GRIT_IMG_TRANS)
		{
			RGBQUAD *rgb= &mgr->img_trans;
			mImgMode= IMG_MODE_BMP_T;
			mImgTransStr.Format("%02X%02X%02X", rgb->rgbRed, 
				rgb->rgbGreen, rgb->rgbBlue);
		}
		else if(mgr->img_flags & GRIT_IMG_BMP_A)
			mImgMode= IMG_MODE_BMP_T;			
		else if(mgr->img_flags & GRIT_IMG_BMP)
			mImgMode= IMG_MODE_BMP;			
		else
			mImgMode= IMG_MODE_TILE;			

		//mgr->img_ofs;
		//mgr->img_bpp;

		// map
		if(mbMap)
		{
			if(mgr->map_flags & GRIT_MAP_REG)
				dw= IDC_MAP_SBB;
			if(mgr->map_flags & GRIT_MAP_AFF)
				dw= IDC_MAP_AFF;
			moMapFormat= dw-IDC_MAP_FLAT;

			if(mgr->map_flags & GRIT_RDX_ON)
			{	
				mbMapRdx= TRUE;
				mbMapRdxFlip= mbMapRdxPal= FALSE;
				if(mgr->map_flags & GRIT_RDX_FLIP)
					mbMapRdxFlip= TRUE;
				if(mgr->map_flags & GRIT_RDX_PAL)
					mbMapRdxPal= TRUE;
			}
			mMapOffset= mgr->map_ofs;
		}
		// meta
		if(mbObjCustom)
		{
			mObjHorz= mgr->meta_width;
			mObjVert= mgr->meta_height;
		}
		// area
		mAreaLeft= mgr->area_left;
		mAreaTop= mgr->area_top;
		mAreaWidth= mgr->area_right-mgr->area_left;
		mAreaHeight= mgr->area_bottom-mgr->area_top;

		UpdateData(FALSE);
	}

	return TRUE;
}


BOOL CxpGbaDlg::Validate()
{
	UpdateGitRec(TRUE);
	if(!grit_validate(mgr))
	{
		int res= MessageBox("Validation encountered problems, "
			"accept alterations?", "Validation", MB_YESNO | MB_ICONEXCLAMATION);
		if(res == IDYES)
			UpdateGitRec(FALSE);
		return FALSE;
	}
	else
		return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CxpGbaDlg message handlers


BOOL CxpGbaDlg::OnInitDialog() 
{
	ASSERT(mpDib);
	
	int nclrs= dib_get_nclrs(mpDib);
	if(nclrs > 0 && mPalStart+mPalCount>nclrs)
	{
		mPalStart= 0;
		mPalCount= nclrs;
	}
	if(moAreaSize != 0)
	{
		mAreaLeft= 0;	mAreaWidth= dib_get_width(mpDib);
		mAreaTop=0;		mAreaHeight= dib_get_height(mpDib);
	}
	if(mbSymChk == FALSE)
		mSymName= mDstTitle;

	CDialog::OnInitDialog();
	OnPalChk();
	OnImgChk();
	OnMapChk();
	UpdateObj();
	UpdateMap();
	UpdateArea();

	GetDlgItem(IDC_VAR_NAME)->EnableWindow(mbSymChk);

	//UpdateSummary();

	return TRUE;
}

void CxpGbaDlg::OnOK() 
{
	CString logpath;
	
	GetRootDir(logpath);
	logpath += "\\gxplog.txt";


	FILE *fp= fopen(logpath, "w");
	if(fp)
		log_init(LOG_STATUS, fp);

	if(Validate() == FALSE)
	{
		if(fp)
		{
			log_exit();
			fclose(fp);
		}		
		return;
	}

	GRIT_SHARED *grs= mgr->shared;

	// Read external tileset if required
	// PONDER: move inside grit_run?
	if(mgr->img_flags & GRIT_IMG_SHARED)
	{
		// read file
		grs->dib= dib_load(grs->path, NULL);

		if(grs->dib)
		{
			CLDIB *dib;

			if( dib_get_bpp(grs->dib) != 8 )
			{
				lprintf(LOG_WARNING, 
"  External tileset must be 8bpp. Converting.\n");

				dib= dib_convert(grs->dib, 8, 0);
				dib_free(grs->dib);
				grs->dib= dib;
			}

			if( dib_get_width(grs->dib) != 8 )
			{
				lprintf(LOG_WARNING, 
"  External tileset not tiled yet. Doing so now.\n");

				dib= dib_redim(grs->dib, 8, 8, 0);
				dib_free(grs->dib);
				grs->dib= dib;
			}
		}
		else
			lprintf(LOG_WARNING, 
"  Couldn't load external tileset from \n    %s.\n", grs->path);

		// PONDER: reduce here too?
	}

	int res= grit_run(mgr);

	// Save external tileset if required
	// PONDER: move inside grit_run?
	if(mgr->img_flags & GRIT_IMG_SHARED)
	{
		if( !dib_save(grs->dib, grs->path, NULL) )
		{
			lprintf(LOG_WARNING, 
"  Couldn't save external tileset to \n    %s.\n", grs->path);
		}
	}


	if(fp)
	{
		log_exit();
		fclose(fp);
	}

	if(res == TRUE)
	{
		// PONDER: ask to see log?
		res= MessageBox("Export succeeded. Show log?", NULL, MB_YESNO);	
		if(res == IDYES)
		{
			CLogDlg dlg;
			dlg.SetTextFromFile(logpath);
			dlg.DoModal();
		}
		CDialog::OnOK();
	}
	else
	{
		// PONDER: ask to see log?
		MessageBox("Export failed. Show Log?", NULL, MB_YESNO);	
		if(res == IDYES)
		{
			CLogDlg dlg;
			dlg.SetTextFromFile(logpath);
			dlg.DoModal();
		}	
	}
}

void CxpGbaDlg::OnValidate() 
{
	Validate();	
}

void CxpGbaDlg::OnPalChk() 
{
	UpdateData(TRUE);
	UpdatePal();
}

void CxpGbaDlg::OnImgChk() 
{
	UpdateData(TRUE);
	UpdateImg();
}

void CxpGbaDlg::OnSelendokImgMode() 
{
	UpdateData(TRUE);
	UpdateImg();
}

void CxpGbaDlg::OnImgFormat(int nID)
{
	UpdateData(TRUE);
	UpdateObj();
	UpdateMap();
}

void CxpGbaDlg::OnMapChk() 
{
	UpdateData(TRUE);
	UpdateMap();
}

void CxpGbaDlg::OnMapRdx() 
{
	UpdateData(TRUE);
	UpdateRdx();
}


void CxpGbaDlg::OnObjCustom() 
{
	UpdateData(TRUE);
	UpdateObj();	
}

void CxpGbaDlg::OnAreaFormat(int nID)
{
	UpdateData(TRUE);
	UpdateArea();
}


void CxpGbaDlg::OnSelendokFileType() 
{
	UpdateData();

	char str[MAX_PATH];
	mDstDir= path_get_dir(str, mDstPath, MAX_PATH);
	mDstTitle= path_get_title(str, mDstPath, MAX_PATH);
	//- CFileFilter::GetFileDir(mDstPath, mDstDir);
	//- CFileFilter::GetFileTitle(mDstPath, mDstTitle);
	mDstPath= mDstDir + "\\" + mDstTitle + "." + cFileTypes[mFileType];

	UpdateData(FALSE);
}

void CxpGbaDlg::OnVarChk() 
{
	UpdateData(TRUE);
	GetDlgItem(IDC_VAR_NAME)->EnableWindow(mbSymChk);
}

void CxpGbaDlg::OnTilesetChk() 
{
	UpdateData(TRUE);
	UpdateMap();
}



void CxpGbaDlg::OnFileBrowse() 
{
	CString str;
	str.LoadString(IDS_FLTR_GBA);
	CFileDialog fdlg(TRUE, NULL, NULL, 
		OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, str);

	if(mDstDir == "")
	{
		char str[MAX_PATH];
		GetCurrentDirectory(MAX_PATH, str);
		mDstDir= str;
		//::GetRootDir(mDstDir);
	}
	
	fdlg.m_ofn.lpstrInitialDir= mDstDir;

	fdlg.m_ofn.lpstrTitle= "Get File Path";

	if(fdlg.DoModal() == IDOK)
	{
		SetDstPath(fdlg.GetPathName());
		UpdateData(FALSE);
	}	
}

void CxpGbaDlg::OnTilesetBrowse() 
{
	CString str;

	const int NFILTERS=5;
	FREE_IMAGE_FORMAT iFilters[NFILTERS]= 
	{	FIF_BMP, FIF_GIF, FIF_PCX, FIF_PNG, FIF_TARGA	};

	// Get full list
	int fif_count;
	char buffy[1024];
		
	fif_count= fiFillOfnFilter(buffy, FIF_MODE_EXP_8BPP, iFilters, 5);

	CFileDialog fdlg(TRUE, NULL, NULL, 
		OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, buffy);

	if(mDstDir == "")
	{
		char str[MAX_PATH];
		GetCurrentDirectory(MAX_PATH, str);
		mDstDir= str;
		//::GetRootDir(mDstDir);
	}
	
	fdlg.m_ofn.lpstrInitialDir= mDstDir;
	fdlg.m_ofn.lpstrTitle= "Get Tileset Path";

	if(fdlg.DoModal() == IDOK)
	{
		mTilesetPath= fdlg.GetPathName();
		UpdateData(FALSE);
	}
}


BOOL CxpGbaDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	BOOL bRes= CDialog::OnCommand(wParam, lParam);
	//TRACE("ON_COMMAND: %d:%d, %d\n", HIWORD(wParam), LOWORD(wParam), lParam);

	//if(HIWORD(wParam) == EN_UPDATE) && LOWORD(wParam) != IDC_SUMMARY);
	if(LOWORD(wParam) != IDC_SUMMARY)
		UpdateSummary();

	return bRes;
}

//-
/*
void CxpGbaDlg::SetSrcPath(const CString &fname)
{
	char str[MAX_PATH];

	//CString str(""), fdir, ftitle;
	mSrcPath= fname;

	CFileFilter::GetFileDir(fname, fdir);
	CFileFilter::GetFileTitle(fname, ftitle);
	if(!fdir.IsEmpty())
		str= fdir + "\\";
	if(!ftitle.IsEmpty())
		str += ftitle;
	SetDstPath(str);
}
*/

//! Set the destination path, dir and title
/*!
	\param path Full destination path. 
*/
void CxpGbaDlg::SetDstPath(const char *path)
{
	char str[MAX_PATH], ext[_MAX_EXT];
	mDstDir= path_get_dir(str, path, MAX_PATH);

	strcpy(ext, path_get_ext(path));
	strlwr(ext);
	path_get_title(str, path, MAX_PATH);

	// binary could have multiple exts; skip last
	if(strcmp(ext, "bin")==0)
		path_get_title(str, str, MAX_PATH);
	mDstTitle= str;

	int ii;
	for(ii=0; ii<FMT_END; ii++)
		if(strcmp(ext, cFileTypes[ii])==0)
			break;

	int old= mFileType;
	if(ii != FMT_END)	// known filetype, so change
		mFileType= ii;

	mDstPath= mDstDir + "\\" + mDstTitle + "." + cFileTypes[mFileType];
	
	//if(mFileType != old && !mBusy)
	//	UpdateData(FALSE);
}
